package cn.com.infosec.asn1.pkcs;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import java.math.BigInteger;
import java.util.Enumeration;

public class DHParameter extends ASN1Encodable {
   DERInteger p;
   DERInteger g;
   DERInteger l;

   public DHParameter(BigInteger p, BigInteger g, int l) {
      DERInteger var4;
      var4 = new DERInteger.<init>(p);
      this.p = var4;
      DERInteger p1;
      p1 = new DERInteger.<init>(g);
      this.g = p1;
      if (l != 0) {
         DHParameter var10000 = this;
         DERInteger var5;
         var5 = new DERInteger.<init>(l);
         var10000.l = var5;
      } else {
         this.l = null;
      }

   }

   public DHParameter(ASN1Sequence seq) {
      Enumeration seq1;
      this.p = (DERInteger)(seq1 = seq.getObjects()).nextElement();
      this.g = (DERInteger)seq1.nextElement();
      if (seq1.hasMoreElements()) {
         this.l = (DERInteger)seq1.nextElement();
      } else {
         this.l = null;
      }

   }

   public BigInteger getP() {
      return this.p.getPositiveValue();
   }

   public BigInteger getG() {
      return this.g.getPositiveValue();
   }

   public BigInteger getL() {
      DERInteger var1;
      return (var1 = this.l) == null ? null : var1.getPositiveValue();
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10001 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.p);
      var10001.add(this.g);
      if (this.getL() != null) {
         var1.add(this.l);
      }

      return new DERSequence(var1);
   }
}
